import { KoliBri } from '@public-ui/schema';
import { KOL_ICON } from './defaults/icon';

/**
 * Online-Styleguide des Freistaates Thüringen
 * - https://thueringen.de/styleguide/
 */
export const TH = KoliBri.createTheme('th', {
	GLOBAL:
		'/* https: //thueringen.de/styleguide/styleguide.063.20210902/?p=dokumentation-basiselemente */ /* @import url("https://fonts.cdnfonts.com/css/source-sans-pro"); */:host {--th-color-unknown: rgb(222, 0, 222);--th-color-blau-darker: rgb(0, 100, 140);--th-color-blau-dark: rgb(0, 118, 166);--th-color-blau: rgb(0, 137, 193);--th-color-blau-light: rgb(91, 179, 218);--th-color-blau-lighter: rgb(148, 200, 228);--th-color-blau-lightest: rgb(200, 224, 239);--th-color-grau-darker: rgb(136, 136, 136);--th-color-grau-dark: rgb(156, 156, 156);--th-color-grau: rgb(177, 177, 177);--th-color-grau-light: rgb(197, 197, 197);--th-color-grau-lighter: rgb(217, 217, 217);--th-color-grau-lightest: rgb(230, 230, 230);--th-color-black: black;--th-color-white: white;--th-color-rot-darker: rgb(152, 35, 15);--th-color-rot-dark: rgb(190, 44, 19);--th-color-rot: rgb(229, 53, 23);--th-color-rot-lightest: rgb(253, 214, 195);--th-color-orange-darker: rgb(115, 67, 0);--th-color-orange-dark: rgb(166, 97, 0);--th-color-orange: rgb(241, 140, 0);--th-color-orange-lightest: rgb(254, 228, 201);--th-color-dunkelgruen-darker: rgb(50, 100, 0);--th-color-dunkelgruen-dark: rgb(65, 128, 0);--th-color-dunkelgruen: rgb(106, 176, 35);--th-color-dunkelgruen-lightest: rgb(222, 239, 212);--th-color-hellgruen-dark: rgb(170, 170, 12);--th-color-hellgruen: rgb(201, 211, 14);--th-color-hellgruen-lightest: rgb(233, 240, 196);--th-color-gelb-dark: rgb(216, 174, 0);--th-color-gelb: rgb(255, 204, 0);--th-color-gelb-lightest: rgb(255, 236, 189);--th-color-hellgelb-dark: rgb(235, 200, 0);--th-color-hellgelb: rgb(255, 232, 0);--th-color-hellgelb-lightest: rgb(255, 247, 193);--th-font-family: "Source Sans Pro", "Helvetica Neue", Helvetica, Arial,sans-serif; /* https: //fonts.google.com/specimen/Source+Sans+Pro */--font-size: 16px;--th-hyphens: auto;--th-line-height: 1.5em;--th-spacing: 0.25em;}:host * {box-sizing: border-box;font-family: var(--th-font-family);}:host h1,:host h2,:host h3,:host h4,:host h5,:host h6 {margin: 0;font-family: var(--th-font-family);}a,button,input,option,select,summary,textarea {-ms-hyphens: auto;-webkit-hyphens: auto;hyphens: auto;letter-spacing: inherit;word-break: break-word;}a:focus,button:focus,input:focus,select:focus,summary:focus,textarea:focus {cursor: pointer;outline-color: var(--th-color-blau);outline-offset: 2px;outline-style: solid;outline-width: 3px;transition: outline-offset 0.2s linear;}@keyframes spin {0% {transform: rotate(0deg);}100% {transform: rotate(360deg);}}',
	'KOL-BUTTON':
		':host {display: inline-block;}button {background-color: transparent;border: 0;cursor: pointer;min-width: 44px;min-height: 44px;padding: 0;text-decoration: none !important;}button > kol-span-wc {font-style: normal;font-weight: 400;border-radius: 0;border-style: solid;border-width: 1px;display: inline-block;line-height: 1;text-align: center;vertical-align: middle;-webkit-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;padding: 0.625em 1em;font-size: 1em;transition: all 0.2s ease-in-out;}button.primary > kol-span-wc,button.primary:disabled:hover > kol-span-wc {background-color: var(--th-color-blau);border-color: var(--th-color-blau);color: var(--th-color-white);}button.secondary > kol-span-wc,button.secondary:disabled:hover > kol-span-wc {background-color: var(--th-color-blau-lightest);border-color: var(--th-color-blau-lightest);color: var(--th-color-blau-darker);}button.normal > kol-span-wc,button.normal:disabled:hover > kol-span-wc {background-color: var(--th-color-grau-darker);border-color: var(--th-color-grau-darker);color: var(--th-color-white);}button.danger > kol-span-wc,button.danger:disabled:hover > kol-span-wc {background-color: var(--th-color-rot);border-color: var(--th-color-rot);color: var(--th-color-black);}button.ghost > kol-span-wc,button.ghost:disabled:hover > kol-span-wc {background-color: var(--th-color-white);border-color: var(--th-color-blau-darker);color: var(--th-color-blau-darker);}button.primary:hover > kol-span-wc,button.primary:focus > kol-span-wc,button.secondary:hover > kol-span-wc,button.secondary:focus > kol-span-wc,button.normal:hover > kol-span-wc,button.normal:focus > kol-span-wc,button.danger:hover > kol-span-wc,button.danger:focus > kol-span-wc,button.ghost:hover > kol-span-wc,button.ghost:focus > kol-span-wc {background-color: var(--th-color-rot-darker);border-color: var(--th-color-rot-darker);color: var(--th-color-white);}button:active {outline: 0 !important;}button:disabled {cursor: not-allowed;opacity: 0.5;}kol-button-wc {width: inherit;}button > kol-span-wc {display: grid;gap: 0.25em;}button > kol-span-wc span {display: flex;gap: 0.25em;align-items: center;justify-content: center;}button.icon-only > kol-span-wc > span > span {display: none;}button.loading > kol-span-wc kol-icon {animation: spin 5s infinite linear;}',
	'KOL-ALERT':
		':host > div {background-color: white;border-width: 2px;border-style: solid;display: flex;overflow: unset;}:host > div.default {background-color: var(--th-color-grau-lightest);border-color: var(--th-color-grau-darker);color: var(--th-color-black);}:host > div.default > .icon {background-color: var(--th-color-grau-dark);}:host > div.error {background-color: var(--th-color-rot-lightest);border-color: var(--th-color-rot-darker);color: var(--th-color-rot-darker);}:host > div.error > .icon {background-color: var(--th-color-rot-dark);}:host > div.info {background-color: var(--th-color-blau-lightest);border-color: var(--th-color-blau-darker);color: var(--th-color-blau-darker);}:host > div.info > .icon {background-color: var(--th-color-blau);}:host > div.success {background-color: var(--th-color-dunkelgruen-lightest);border-color: var(--th-color-dunkelgruen-darker);color: var(--th-color-dunkelgruen-darker);}:host > div.success > .icon {background-color: var(--th-color-dunkelgruen-dark);}:host > div.warning {background-color: var(--th-color-orange-lightest);border-color: var(--th-color-orange-darker);color: var(--th-color-orange-darker);}:host > div.warning > .icon {background-color: var(--th-color-orange-dark);}:host > div.msg > .icon {color: white;padding: 0.5em;align-items: center;display: inline-flex;}:host > div.card.default .heading .icon {background-color: var(--th-color-grau-darker);}:host > div.card.error .heading .icon {background-color: var(--th-color-rot-dark);}:host > div.card.info .heading .icon {background-color: var(--th-color-blau);}:host > div.card.success .heading .icon {background-color: var(--th-color-dunkelgruen-dark);}:host > div.card.warning .heading .icon {background-color: var(--th-color-orange-dark);}:host > div.card .heading .icon {color: white;padding: 0.5em;align-items: center;display: inline-flex;}:host > div kol-heading-wc .icon {margin-right: 0.5em;}:host > div.card .heading .icon {border-radius: 0 0 0.25rem 0;}:host > div.msg > div {padding: 0.25em;}:host > div.msg > div > .heading {padding: 0.25em;display: inline-block;}:host > div .content {padding: 0.25em;}:host > div > div {display: grid;grid-template-columns: 1fr auto;}:host > div > div > .content {grid-row: 2;grid-column: 1;}:host > div > div > .close {grid-row: 1 / span 2;display: flex;}:host > div.msg > div > .close > * {margin: auto;}:host > div.msg.default .close .icon {color: var(--th-color-grau-darker);}:host > div.msg.error .close .icon {color: var(--th-color-rot);}:host > div.msg.info .close .icon {color: var(--th-color-blau-dark);}:host > div.msg.success .close .icon {color: var(--th-color-green);}:host > div.msg.warning .close .icon {color: var(--th-color-orange);}:host > div.card > div > .heading {width: 100%;}.close > button {min-width: 44px;min-height: 44px;display: grid;gap: 0.25em;line-height: 1.5rem;font-family: var(--th-font-family);font-weight: 700;cursor: pointer;border-radius: 1.5em;border-style: solid;border-width: 2px;font-size: 1rem;align-items: center;padding: 8px 14px;justify-content: center;font-style: normal;text-align: center;text-transform: uppercase;width: inherit;transition-duration: 0.5s;transition-property: background-color, color, border-color;background-color: rgba(0, 0, 0, 0);border-color: rgba(0, 0, 0, 0);}.close > button.icon-only {padding: 8px;}.close > button.icon-only kol-icon {display: inline-block;width: 1.5em;height: 1.5em;}.close > button:active {box-shadow: none;outline: none;}.close kol-icon::part(icon)::before {content: "\\f00d";}',
	'KOL-INPUT-TEXT':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-BUTTON-GROUP': 'div {display: inline-flex;flex-wrap: wrap;padding: 0.25em;border-radius: 5px;gap: 0.25em;}',
	'KOL-INPUT-PASSWORD':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-INPUT-NUMBER':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-INPUT-EMAIL':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-INPUT-FILE':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-TEXTAREA':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-HEADING':
		'h1,h2,h3,h4,h5,h6 {line-height: 1.125em;margin: 0;}h2,h3,h4,h5,h6 {font-style: normal;font-weight: 700;}h1 {color: var(--th-color-blau);font-size: 2.125em;font-weight: 400;padding-bottom: 1.0625em;padding-top: 1.5em;}h2 {color: var(--th-color-black);font-size: 1.625em;padding-bottom: 0.8125em;padding-top: 1.5em;}h3,h4 {font-size: 1.375em;padding-bottom: 0.6875em;padding-top: 1.5em;}h3 {color: var(--th-color-blau);}h4 {color: var(--th-color-black);}h5,h6 {font-size: 1em;padding-bottom: 0.5em;padding-top: 1em;}h5 {color: var(--th-color-blau);}h6 {color: var(--th-color-black);}',
	'KOL-INPUT-CHECKBOX':
		':host {--border-width: 1px;}label {cursor: pointer;}input {color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: var(--border-width);border-style: solid;line-height: 24px;font-size: 16px;}.required label > span::after {content: "*";padding-left: 0.125em;}input:hover {border-color: var(--th-color-blau);} /* NEU */kol-input {display: grid;align-items: center;justify-items: left;width: 100%;}kol-input.checkbox {grid-template-columns: calc(6 * var(--th-spacing)) auto;}kol-input.switch {grid-template-columns: calc(13 * var(--th-spacing)) auto;}kol-input > div.input {display: inline-flex;order: 1;}kol-input > div.input input {margin: 0px;}kol-input > label {order: 2;padding-left: calc(2 * var(--th-spacing));}kol-input > kol-alert.error {order: 3;padding-top: 0.25em;grid-column: span 2 / auto;} /* CHECKBOX */input[type="checkbox"] {appearance: none;background-color: white;cursor: pointer;transition: 0.5s;}input[type="checkbox"].kol-disabled:before {cursor: not-allowed;}input[type="checkbox"]:before {content: "";cursor: pointer;}input[type="checkbox"]:checked {background-color: var(--th-color-blau);border-color: var(--th-color-blau);}.checkbox input[type="checkbox"] {height: calc(6 * var(--th-spacing));min-width: calc(6 * var(--th-spacing));width: calc(6 * var(--th-spacing));}.checkbox input[type="checkbox"]:before {background-color: transparent;display: block;height: calc(6 * var(--th-spacing));position: relative;width: calc(6 * var(--th-spacing));}.checkbox input[type="checkbox"]:checked:before {border-right-width: 3px;border-bottom-width: 3px;left: calc(1.5 * var(--th-spacing) - var(--border-width));top: calc(2.85 * var(--th-spacing) - var(--border-width));transform: rotate(40deg) translate(-50%, -50%);background-color: transparent;border-width: 0px 3px 3px 0px;border-color: white;border-style: solid;height: calc(3 * var(--th-spacing));width: calc(1.5 * var(--th-spacing));}.checkbox input[type="checkbox"]:indeterminate:before {background-color: var(--th-color-unknown);height: 0.375rem;top: 0.45rem;left: 0.15rem;width: calc(4 * var(--th-spacing));}.switch input[type="checkbox"] {min-width: 3.2em;width: 3.2em;height: 1.7em;display: inline-block;position: relative;}.switch input[type="checkbox"]:before {-webkit-transition: 0.5s;-moz-transition: 0.5s;-ms-transition: 0.5s;transition: 0.5;width: 1.2em;height: 1.2em;left: calc(0.25em - var(--border-width));top: calc(0.25em - var(--border-width));background-color: black;position: absolute;}.switch input[type="checkbox"]:checked:before {-webkit-transform: translateX(1.5em);-moz-transform: translateX(1.5em);-ms-transform: translateX(1.5em);transform: translateX(1.5em);background-color: white;}.switch input[type="checkbox"]:indeterminate:before {-webkit-transform: translateX(0.75em);-moz-transform: translateX(0.75em);-ms-transform: translateX(0.75em);transform: translateX(0.75em);background-color: var(--th-color-blau);}.disabled {opacity: 0.33;}',
	'KOL-INPUT-RADIO':
		':host {--border-width: 1px;}label {cursor: pointer;display: grid;font-size: 14px;line-height: 20px;gap: 8px;width: 100%;}input {cursor: pointer;width: 100%;border-color: var(--th-color-grau-darker);border-width: var(--border-width);border-style: solid;border-radius: 5px; /* padding: 10px 14px; */line-height: 24px;font-size: 16px;}input:hover {border-color: var(--th-color-blau);}kol-alert {display: block;width: 100%;margin-bottom: 0.4em;}.required label > span::after {content: "*";padding-left: 0.125em;} /* RADIO */:host fieldset {border: 0px;margin: 0px;padding: 0px;display: grid;gap: 0.25em;}:host fieldset div {cursor: pointer;display: flex;flex-direction: row;margin-top: 0.125em;margin-bottom: 0.125em;align-items: center;position: relative;}:host fieldset div label {cursor: pointer;display: flex;padding-left: 0.25em;width: 100%;}:host fieldset div label span {margin-top: 0.125em;}:host fieldset div input[type="radio"] {appearance: none;transition: 0.5s;border-radius: 100%;height: calc(6 * var(--th-spacing));min-width: calc(6 * var(--th-spacing));width: calc(6 * var(--th-spacing));}:host fieldset div input[type="radio"]:before {content: "";cursor: pointer;left: calc(1.5 * var(--th-spacing) - var(--border-width));top: calc(1.5 * var(--th-spacing) - var(--border-width));position: relative;border-radius: 100%;display: block;height: calc(3 * var(--th-spacing));width: calc(3 * var(--th-spacing));}:host fieldset div input[type="radio"]:checked:before {background-color: var(--th-color-blau);}:host fieldset #error {margin: 0.4em 0;order: 3;}:host fieldset legend {order: 1;display: contents;}:host fieldset kol-input {order: 2;}.disabled {opacity: 0.33;}:host fieldset.horizontal {display: flex;flex-wrap: wrap;gap: 0.5rem 1rem;}:host fieldset.horizontal legend {display: inline-block;margin-bottom: 0.25em;}',
	'KOL-BADGE':
		':host {display: inline-block;}kol-span-wc {align-items: center;border-radius: 0.3125rem;display: grid;gap: 0.5rem;line-height: 1.25rem;padding: 0.25rem 0.75rem;}kol-span-wc span {display: flex;gap: 0.25rem;}',
	'KOL-INDENTED-TEXT': ':host > div {width: 100%;border-left-style: solid;border-left-width: 0.25em;border-left-color: var(--th-color-grau);padding: 0 0.5em;}',
	'KOL-LINK':
		':host {display: inline;}:host > kol-link-wc,:host > kol-link-wc a,:host > kol-link-wc a sup,:host > kol-link-wc a kol-icon {display: inline;}a {color: var(--th-color-black);display: inline-flex;flex-wrap: wrap;line-height: 1.5em;padding: 0.25em;text-decoration-color: var(--th-color-grau-darker);text-decoration-line: underline;transition: all 0.05s ease-in-out;}a:active,a:focus {background-color: var(--th-color-rot-darker);color: var(--th-color-white);}a:active,a:focus,a:hover {text-decoration-color: var(--th-color-rot-darker);text-decoration-thickness: 0.2em;}kol-icon {padding: 0 0.25em;display: inline-block;}kol-icon + span,span + kol-icon {padding-left: 0.25em;}.hidden {display: none;visibility: hidden;}:host a.skip {left: -99999px;overflow: hidden;position: absolute;z-index: 9999999;line-height: 1em;}:host a.skip:focus {left: unset;position: unset;}',
	'KOL-BREADCRUMB':
		'/* https: //thueringen.de/styleguide/styleguide.063.20210902/?p=inhaltsmodule-nav-path */nav {width: 100%;}ul {margin: 0;padding: 0;list-style: none;display: flex;flex-wrap: wrap;align-items: center;}kol-link {display: inline;}span {line-height: 1.5em;}i[part*="separator"]::before {font-family: "Icofont";font-style: normal;content: "\\ea5d";}',
	'KOL-DETAILS':
		'summary {cursor: pointer;display: flow-root;}summary span {text-decoration: underline;}summary span:hover {text-decoration-thickness: 0.25em;}kol-indented-text {margin-left: 0.25em;display: inline-block;}',
	'KOL-SPIN':
		'.spin {display: inline-block;height: 1rem;position: relative;width: 3rem;}.spin span {animation-timing-function: cubic-bezier(0, 1, 1, 0);border: 0.1rem solid rgb(255, 255, 255);border-radius: 50%;height: 0.8rem;width: 0.8rem;top: 0.1rem;position: absolute;}.spin span:nth-child(1) {background-color: #fc0;z-index: 0;animation: 2s ease 0s infinite normal none running spin1;left: 0.1rem;}.spin span:nth-child(2) {background-color: #f00;z-index: 1;animation: 2s ease 0s infinite normal none running spin2;left: 0.1rem;}.spin span:nth-child(3) {background-color: #000;z-index: 1;animation: 2s ease 0s infinite normal none running spin2;left: 1.1rem;}.spin span:nth-child(4) {background-color: #666;z-index: 0;animation: 2s ease 0s infinite normal none running spin3;left: 2.1rem;}@keyframes spin1 {0% {transform: scale(0);}100% {transform: scale(1);}}@keyframes spin2 {0% {transform: translate(0px, 0px);}100% {transform: translate(1rem, 0px);}}@keyframes spin3 {0% {transform: scale(1);}100% {transform: scale(0);}}',
	'KOL-PROGRESS':
		':host progress,:host span {display: block;height: 0px;overflow: hidden;width: 0px;}svg line:first-child,svg circle:first-child {fill: transparent;stroke: var(--th-color-grau-lighter);}svg line:last-child,svg circle:last-child {stroke: var(--th-color-blau-darker);fill: transparent;}progress {display: none;}',
	'KOL-SELECT':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-INPUT-COLOR':
		'kol-input {display: grid;padding: 0;margin: 0;}input:focus,input:hover,select:focus,select:hover,textarea:focus,textarea:hover {background-color: var(--th-color-hellgelb-lightest);border-color: var(--th-color-black);}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;padding: 0.5em 0.75em;overflow: hidden;width: 100%;}input:not([type="range"]),select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em;}.icon-left input,.icon-left select {padding-left: 2em;}.icon-right input,.icon-right select {padding-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}select[multiple],textarea {overflow: auto;}textarea {display: block;}select option {margin: 1px 0;padding: 0.5em;cursor: pointer;}select option:disabled {cursor: not-allowed;}option:active:not(:disabled),option:checked:not(:disabled),option:focus:not(:disabled),option:hover:not(:disabled) {background-color: var(--th-color-blau);color: white;}',
	'KOL-ACCORDION':
		'/* https: //thueringen.de/styleguide/styleguide.063.20210902/?p=inhaltsmodule-collapse */:host > div {font-family: var(--th-font-family);box-sizing: border-box;width: 100%;height: 100%;display: grid;border-color: var(--th-color-grau-darker);border-width: 1px;border-style: solid;border-radius: 0.25rem;}:host > div > kol-heading-wc {font-weight: 700;font-size: 1.25rem;line-height: 1.75rem;}:host > div > kol-heading-wc button {cursor: pointer;width: 100%;margin: 0;display: flex;gap: 0.5em;border: 0;align-items: center;overflow: hidden;font-size: inherit;line-height: 1.75em;background-color: transparent;padding: 0.5rem;}:host > div[part*="open"] > kol-heading-wc button {padding-bottom: 0;}:host > div[part*="open"] > kol-heading-wc button kol-icon {width: 1em;}:host > div div[part="header"],:host > div[part*="open"] div[part="content"] {margin: 0;padding-left: 2.5em;}:host > div > kol-heading-wc button kol-icon::part(icon) {color: var(--th-color-blau-dark);}button {cursor: pointer;font-weight: inherit;font-size: inherit;line-height: inherit;}',
	'KOL-CARD':
		':host > div {border-color: var(--th-color-grau-darker);border-style: solid;border-width: 2px;border-radius: 0.25rem;display: grid;width: 100%;height: 100%;background-color: white;grid-template-rows: min-content 2fr min-content;}:host kol-heading-wc {display: inline-flex;font-style: normal;font-weight: 700;font-size: 1.25rem;line-height: 1.75rem;}:host div.footer,:host div.header {padding: 0.5rem;}:host div.content {padding: 0;}:host div.content,:host div.content + div.footer {border-top: 1px solid var(--th-color-grau-darker);}',
	'KOL-LINK-GROUP':
		'ul {list-style: none;margin: 0px;padding: 0px;}nav.horizontal ul {display: flex;flex-wrap: wrap;}nav.horizontal li {margin-left: 1.25rem;margin-right: 0.25rem;}nav.horizontal li:first-child {margin-left: 0;}nav.horizontal li:last-child {margin-right: 0;}nav.vertical li {margin-left: 1.75rem;margin-right: 0.5rem;}li.list-none {list-style-type: none !important;margin-left: 0;}',
	'KOL-PAGINATION':
		':host {display: grid;gap: 1rem;}:host > div {display: inline-flex;flex-wrap: wrap;align-items: center;gap: 0.5em;}.selected button {background-color: transparent;border: 0;cursor: not-allowed;min-width: 44px;min-height: 44px;padding: 0;text-decoration: none !important;}.selected button > kol-span-wc {font-style: normal;font-weight: 700;border-radius: 0;border-style: solid;border-width: 1px;display: inline-block;line-height: 1;text-align: center;vertical-align: middle;-webkit-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;padding: 0.625em 1em;font-size: 1em;transition: all 0.2s ease-in-out;text-decoration: underline;}.selected button > kol-span-wc,.selected button:disabled:hover > kol-span-wc {background-color: var(--th-color-blau);border-color: var(--th-color-blau);color: var(--th-color-white);}',
	'KOL-TABS':
		':host {font-family: var(--th-font-family);}:host > div {display: block;width: 100%;}:host kol-button-group {display: inline-block;border-radius: 0.25rem 0.25rem 0 0;background-color: var(--th-color-blau-darker);}:host kol-button-group > div {display: inline-flex;}:host kol-button-group > div + div {margin-left: 0.25em;}:host > div > div {padding: 0.25em;border: 1px solid var(--th-color-grau-dark);border-radius: 0 0 0.25rem 0.25rem;}button {box-sizing: border-box;font-size: inherit;line-height: 1.25em;cursor: pointer;border-width: 2px;box-shadow: 0 0 0.25em gray;font-family: var(--th-font-family);width: inherit;border-style: solid;padding: calc(2 * var(--th-spacing));display: grid;gap: 0.25em;align-items: center;justify-content: center;text-align: center;transition-duration: 0.5s;transition-property: background-color, color, border-color;}kol-button-wc[aria-selected="true"] button {border-bottom-width: 0.25em !important;border-bottom-style: solid;border-bottom-color: var(--th-color-gelb) !important;}button > kol-span-wc span {display: flex;gap: 0.25em;align-items: center;justify-content: center;}button:disabled {cursor: not-allowed;opacity: 0.5;}button.primary,button.primary:disabled:hover {background-color: var(--th-color-blau);border-color: var(--th-color-blau);color: var(--th-color-white);}button.primary:hover,button.primary:focus {color: var(--th-color-blau);}button.secondary,button.secondary:disabled:hover {background-color: var(--th-color-grau);border-color: var(--th-color-grau);color: white;}button.secondary:hover,button.secondary:focus {color: var(--th-color-grau);}button.normal,button.normal:disabled:hover {background-color: var(--th-color-blau);border-color: var(--th-color-blau);color: var(--th-color-white);}button.normal:hover,button.normal:focus {color: var(--th-color-blau);}button.danger,button.danger:disabled:hover {background-color: var(--th-color-rot);border-color: var(--th-color-rot);color: white;}button.danger:hover,button.danger:focus {color: var(--th-color-rot);}button.ghost,button.ghost:disabled:hover {background-color: white;border-color: var(--th-color-white);color: var(--th-color-white);}button.ghost:hover,button.ghost:focus {background-color: var(--th-color-white);color: var(--th-color-white);}button:hover,button:focus {background-color: var(--th-color-white);box-shadow: 0 0 0.25em var(--th-color-black);}button:active {outline: 0 !important;box-shadow: none !important;}.close-button {font-size: 25%;height: fit-content;width: 0;}.close-button button {width: 1rem;position: relative;height: 1rem;left: -4.25em;top: 0.25em;}',
	'KOL-TOAST':
		':host > div {position: fixed;top: 0;left: 0;width: 100%;height: 0;z-index: 200;}:host > div > kol-alert {display: block;margin: auto;padding: 1rem;max-width: 750px;}:host > div > kol-button-wc {top: 0;position: relative;display: block;margin: auto;width: 1em;}',
	'KOL-INPUT-RANGE':
		'kol-input {display: grid;padding: 0;margin: 0;}kol-input > label {order: 1;margin-bottom: 0.25em;}kol-input > label > span {color: var(--th-color-black);font-size: 0.875rem;line-height: 1.5rem;}kol-input > div.input {background-color: white;border-radius: 0.25rem;display: block;order: 2;}kol-input > kol-alert.error {margin-top: 0.25em;order: 3;}input,select,textarea {font-family: var(--th-font-family);background-color: transparent;box-sizing: border-box;font-size: 1rem;display: inline-flex;line-height: 1.5em;color: var(--th-color-black);border-color: var(--th-color-grau-darker);border-width: 2px;border-style: solid;padding: 0.5em 0.75em;border-radius: 0.25rem;overflow: hidden;width: calc(100% - 4em);}input/*:not([type="range"])*/,select:not([multiple]) {height: 2.75em;}textarea {display: inherit;}input::placeholder {color: var(--th-color-grau-darker);}input:not([type="color"]):read-only,input:disabled,/* select:read-only, */select:disabled,textarea:read-only,textarea:disabled {cursor: not-allowed;border-color: var(--th-color-grau-darker);background-color: var(--th-color-grau-darker);}.required label > span::after {content: "*";padding-left: 0.125em;}.icons {display: flex;justify-content: space-between;height: 0;}.icons > * {margin: 0.75em 0.5em;border-color: transparent;border-width: 2px;border-style: solid;}.icon-left input,.icon-left select {margin-left: 2em;}.icon-right input,.icon-right select {margin-right: 2em;}kol-button-wc {position: relative;float: right;z-index: 1000;margin-top: -33px;}kol-button-wc button {border: 1px solid var(--th-color-grau-darker);border-radius: 0.25rem;box-sizing: border-box;background-color: transparent;cursor: pointer;}.icon-right kol-button-wc {margin-right: 2.5em;}.disabled {opacity: 0.33;}',
	'KOL-NAV':
		':host {--border-radius: 0em;}:host * {hyphens: var(--th-hyphens);font-family: var(--th-font-family);line-height: var(--th-line-height);word-break: break-word;}:host .hidden {display: none;}:host > div > nav ul {list-style: none;margin: 0px;padding: 0px;border-radius: var(--border-radius);background-color: var(--th-color-blau-dark);}:host > div > nav ul > li {border-radius: var(--border-radius);overflow: hidden;padding: 0.125em;}:host > div > nav ul > li[part*="vertical"] + li {border-radius: 0;border-top: 0.1em dotted white;}:host > div > nav ul > li[part*="vertical selected"] {border-right: 0.375em solid var(--th-color-gelb);}:host > div > nav ul > li[part*="horizontal"] + li {border-radius: 0;border-left: 0.1em dotted white;}:host > div > nav ul > li[part*="horizontal selected"] {border-bottom: 0.375em solid var(--th-color-gelb);}:host > div > nav ul > li > div {height: 100%;}:host > div > nav kol-link-wc {width: 100%; /*height: 100%;font-weight: 600;*/display: block;}:host > div > nav kol-link-wc a {border-radius: var(--border-radius);background-color: var(--th-color-blau-dark);border: 1px solid transparent;grid: flex;line-height: 2em;padding: 0.5em;color: white;height: 100%;-webkit-box-align: center;align-items: center;flex-wrap: wrap;display: flex;cursor: pointer;text-decoration: inherit;}:host > div > nav kol-link-wc a[part*="selected"] {background-color: var(--th-color-active);font-weight: 700;}:host > div > nav kol-link-wc a kol-icon.mr-2 {margin-right: calc(2 * var(--th-spacing));}:host > div > nav kol-link-wc a kol-icon.ml-2 {margin-left: calc(2 * var(--th-spacing));}:host > div > nav kol-link-wc a:focus,:host > div > nav kol-link-wc a:hover {border: 1px solid white;background-color: var(--th-color-focus);} /* compact button */:host > div > div:last-child {margin-top: 0.5em;width: 100%;text-align: center;}:host > div > nav kol-link-wc a.text-center {display: grid;align-items: center;justify-items: center;} /* horizontal */ul.flex {display: flex;}li > div > div.absolute {position: absolute;}',
	'KOL-TABLE':
		':host * {hyphens: var(--th-hyphens);font-family: var(--th-font-family);line-height: var(--th-line-height);word-break: break-word;}:host > div {overflow-x: auto;overflow-y: hidden;}:host > div:first-child {border-style: solid;border-width: 1px;border-color: var(--th-color-grau-darker);}table {width: 100%;border-collapse: collapse;border-spacing: 0;}table,tr,th,td {border: 0 solid var(--th-color-grau-darker);}tr {border-top-width: 1px;}tr:nth-child(even) {background-color: #f2f2f2;}th,td {border-right-width: 1px;padding: 0.25em 0.5em;}th {background-color: #eee;}th > div {display: grid;grid-template-columns: 1fr auto;align-items: center;gap: 0.25em;}:host > div.pagination {padding: 0.5em;}:host > div:last-child,:host > div.pagination > div:last-child {display: grid;align-items: center;justify-items: center;gap: 0.5em;}@media (min-width: 1024px) {:host > div:last-child,:host > div.pagination > div:last-child {grid-auto-flow: column;}:host > div.pagination kol-pagination {display: flex;gap: 1rem;}}',
	'KOL-LINK-BUTTON':
		':host {display: inline-block;}a {background-color: transparent;border: 0;cursor: pointer;min-width: 44px;min-height: 44px;padding: 0;text-decoration: none !important;}a > kol-span-wc {font-style: normal;font-weight: 400;border-radius: 0;border-style: solid;border-width: 1px;display: inline-block;line-height: 1;text-align: center;vertical-align: middle;-webkit-user-select: none;-moz-user-select: none;-ms-user-select: none;user-select: none;padding: 0.625em 1em;font-size: 1em;transition: all 0.2s ease-in-out;}a.primary > kol-span-wc,a.primary:disabled:hover > kol-span-wc {background-color: var(--th-color-blau);border-color: var(--th-color-blau);color: var(--th-color-white);}a.secondary > kol-span-wc,a.secondary:disabled:hover > kol-span-wc {background-color: var(--th-color-blau-lightest);border-color: var(--th-color-blau-lightest);color: var(--th-color-blau-darker);}a.normal > kol-span-wc,a.normal:disabled:hover > kol-span-wc {background-color: var(--th-color-grau-darker);border-color: var(--th-color-grau-darker);color: var(--th-color-white);}a.danger > kol-span-wc,a.danger:disabled:hover > kol-span-wc {background-color: var(--th-color-rot);border-color: var(--th-color-rot);color: var(--th-color-black);}a.ghost > kol-span-wc,a.ghost:disabled:hover > kol-span-wc {background-color: var(--th-color-white);border-color: var(--th-color-blau-darker);color: var(--th-color-blau-darker);}a.primary:hover > kol-span-wc,a.primary:focus > kol-span-wc,a.secondary:hover > kol-span-wc,a.secondary:focus > kol-span-wc,a.normal:hover > kol-span-wc,a.normal:focus > kol-span-wc,a.danger:hover > kol-span-wc,a.danger:focus > kol-span-wc,a.ghost:hover > kol-span-wc,a.ghost:focus > kol-span-wc {background-color: var(--th-color-rot-darker);border-color: var(--th-color-rot-darker);color: var(--th-color-white);}a:active {outline: 0 !important;}a:disabled {cursor: not-allowed;opacity: 0.5;}kol-a-wc {width: inherit;}a > kol-span-wc {display: grid;gap: 0.25em;}a > kol-span-wc span {display: flex;gap: 0.25em;align-items: center;justify-content: center;}a.icon-only > kol-span-wc > span > span {display: none;}a.loading > kol-span-wc kol-icon {animation: spin 5s infinite linear;}',
	'KOL-BUTTON-LINK':
		'kol-link-wc {display: inline-block;}button {background-color: transparent;border: 0;color: var(--th-color-black);display: inline-flex;flex-wrap: wrap;line-height: 1.5em;padding: 0 0.25em;text-decoration-color: var(--th-color-grau-darker);text-decoration-line: underline;transition: all 0.05s ease-in-out;}button:active,button:focus {background-color: var(--th-color-rot-darker);color: var(--th-color-white);}button:active,button:focus,button:hover {text-decoration-color: var(--th-color-rot-darker);text-decoration-thickness: 0.2em;}kol-icon {padding: 0 0.25em;display: inline-block;}kol-icon + span,span + kol-icon {padding-left: 0.25em;}.hidden {display: none;visibility: hidden;}:host a.skip {left: -99999px;overflow: hidden;position: absolute;z-index: 9999999;line-height: 1em;}:host a.skip:focus {background: white;left: unset;position: unset;}',
	'KOL-ICON': KOL_ICON,
});
